#include "audiowidget.h"

AudioWidget::AudioWidget(QWidget *parent) :
    QWidget(parent)
{
    layout = new QHBoxLayout();
    for (int i= 0; i < LAYERS_NUMBER; i++ ) {
       // Conectar los slots
        layout->insertWidget(i, new AudioLayerWidget(this, tr("Layer %1").arg(i)));
     }
    setLayout(layout);
    qDebug( "Init AudioWidget");
}

void AudioWidget::mediaLoaded(int layer, QString media)
{
    QLayoutItem * const item = layout->itemAt(layer);
    dynamic_cast<AudioLayerWidget *>(item->widget())->loadMedia(media);
/*    qDebug() << "AudioWidget::mediaLoaded Received layer: " << layer
             << "Media: " << media; */
}

void AudioWidget::volChanged(int layer, qreal vol) {
    QLayoutItem * const item = layout->itemAt(layer);
/*    qDebug() << "AudioWidget::volChanged Received layer: " << layer
             << "Vol : " << vol; */
    dynamic_cast<AudioLayerWidget *>(item->widget())->setVol(vol);
}

void AudioWidget::playbackChanged(int layer, QAudio::State state)
{
    QLayoutItem * const item = layout->itemAt(layer);
    switch (state) {
    case QAudio::ActiveState:
      dynamic_cast<AudioLayerWidget *>(item->widget())->play();
      break;
    case QAudio::StoppedState:
      dynamic_cast<AudioLayerWidget *>(item->widget())->pause();
      break;
    case QAudio::SuspendedState:
      dynamic_cast<AudioLayerWidget *>(item->widget())->resume();
    case QAudio::IdleState:
        break;
    }
}

void AudioWidget::layerReceived(int layer)
{
    QLayoutItem * const item = layout->itemAt(layer);
    dynamic_cast<AudioLayerWidget *>(item->widget())->updateWatchDMX(true);
}
